//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <winuser.h>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  list<char> lst, revlst; //   
  int i;
  for (i=0; i<10; i++) lst.push_back('A' + i);
  cout << ToRus("  lst = ") << lst.size() << endl;
  cout << ToRus(" lst: ");
  list<char>::iterator p = lst.begin();
  /*
      lst   
     revlst   
  */
  while (!lst.empty())
  {
  	p = lst.begin();
  	cout << *p;
  	revlst.push_front(*p);
  	lst.pop_front();
  }
  cout << endl << endl;

  cout << ToRus("  revlst = ");
  cout << revlst.size() << endl;

  cout << ToRus("  : ");
  p = revlst.begin();
  while(p != revlst.end())
  {
  	cout << *p;
  	p++;
  }

  getch();
  return 0;
}
//---------------------------------------------------------------------------
